"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .billofladingfields import BillOfLadingFields, BillOfLadingFieldsTypedDict
from .document import Document, DocumentTypedDict
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class BillOfLadingValidationErrorsTypedDict(TypedDict):
    message: str


class BillOfLadingValidationErrors(BaseModel):
    message: str


class BillOfLadingTypedDict(TypedDict):
    r"""Extracted Bill Of Lading Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[BillOfLadingFieldsTypedDict]
    r"""Fields extracted from a bill of lading"""
    validation_errors: NotRequired[List[BillOfLadingValidationErrorsTypedDict]]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class BillOfLading(BaseModel):
    r"""Extracted Bill Of Lading Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[BillOfLadingFields] = None
    r"""Fields extracted from a bill of lading"""

    validation_errors: Annotated[
        Optional[List[BillOfLadingValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
