"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .commercialinvoicefields import (
    CommercialInvoiceFields,
    CommercialInvoiceFieldsTypedDict,
)
from .document import Document, DocumentTypedDict
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class CommercialInvoiceValidationErrorsTypedDict(TypedDict):
    message: str


class CommercialInvoiceValidationErrors(BaseModel):
    message: str


class CommercialInvoiceTypedDict(TypedDict):
    r"""Extracted Commercial Invoice Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[CommercialInvoiceFieldsTypedDict]
    r"""Fields extracted from a commercial invoice"""
    validation_errors: NotRequired[List[CommercialInvoiceValidationErrorsTypedDict]]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class CommercialInvoice(BaseModel):
    r"""Extracted Commercial Invoice Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[CommercialInvoiceFields] = None
    r"""Fields extracted from a commercial invoice"""

    validation_errors: Annotated[
        Optional[List[CommercialInvoiceValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
