"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .document import Document, DocumentTypedDict
from .invoicefields import InvoiceFields, InvoiceFieldsTypedDict
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class InvoiceValidationErrorsTypedDict(TypedDict):
    message: str


class InvoiceValidationErrors(BaseModel):
    message: str


class InvoiceTypedDict(TypedDict):
    r"""Extracted Invoice Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[InvoiceFieldsTypedDict]
    r"""Fields extracted from an invoice"""
    validation_errors: NotRequired[List[InvoiceValidationErrorsTypedDict]]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class Invoice(BaseModel):
    r"""Extracted Invoice Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[InvoiceFields] = None
    r"""Fields extracted from an invoice"""

    validation_errors: Annotated[
        Optional[List[InvoiceValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
