"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .document import Document, DocumentTypedDict
from .purchaseorderfields import PurchaseOrderFields, PurchaseOrderFieldsTypedDict
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class PurchaseOrderValidationErrorsTypedDict(TypedDict):
    message: str


class PurchaseOrderValidationErrors(BaseModel):
    message: str


class PurchaseOrderTypedDict(TypedDict):
    r"""Extracted Purchase Order Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[PurchaseOrderFieldsTypedDict]
    r"""Fields extracted from a purchase order"""
    validation_errors: NotRequired[List[PurchaseOrderValidationErrorsTypedDict]]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class PurchaseOrder(BaseModel):
    r"""Extracted Purchase Order Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[PurchaseOrderFields] = None
    r"""Fields extracted from a purchase order"""

    validation_errors: Annotated[
        Optional[List[PurchaseOrderValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
