"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .document import Document, DocumentTypedDict
from .seawaybillfields import SeaWaybillFields, SeaWaybillFieldsTypedDict
from abbyy_document_ai.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class SeaWaybillValidationErrorsTypedDict(TypedDict):
    message: str


class SeaWaybillValidationErrors(BaseModel):
    message: str


class SeaWaybillTypedDict(TypedDict):
    r"""Extracted Sea Waybill Data Response"""

    meta: DocumentTypedDict
    r"""Represents a document that has been submitted for processing."""
    fields: NotRequired[SeaWaybillFieldsTypedDict]
    r"""Fields extracted from a sea waybill"""
    validation_errors: NotRequired[List[SeaWaybillValidationErrorsTypedDict]]
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""


class SeaWaybill(BaseModel):
    r"""Extracted Sea Waybill Data Response"""

    meta: Document
    r"""Represents a document that has been submitted for processing."""

    fields: Optional[SeaWaybillFields] = None
    r"""Fields extracted from a sea waybill"""

    validation_errors: Annotated[
        Optional[List[SeaWaybillValidationErrors]],
        pydantic.Field(alias="validationErrors"),
    ] = None
    r"""An array of validation errors that occurred while processing the document. These typically do not prevent field extraction, but rather indicate issues extracting key fields."""
